var nfc = require('ti.nfc');
var nfcAdapter = null;
var dispatchFilter = null;

$.index.addEventListener('open', function(e) {
	setupNfc();
});

$.index.open();

function setupNfc() {
	nfcAdapter = nfc.createNfcAdapter({
		onNdefDiscovered: handleDiscovery,
		onTagDiscovered: handleDiscovery,
		onTechDiscovered: handleDiscovery
	});

	if (!nfcAdapter.isEnabled()) {
		alert('NFC is not enabled on this device');
		return;
	}

	dispatchFilter = nfc.createNfcForegroundDispatchFilter({
		 intentFilters: [
			 {
				 action: nfc.ACTION_NDEF_DISCOVERED,
				 mimeType: '*/*',
			 },
			 {
				 action: nfc.ACTION_NDEF_DISCOVERED,
				 scheme: 'http',
			 },
			 {
				 action: nfc.ACTION_NDEF_DISCOVERED,
				 scheme: 'https',
			 }
	 		],
	});

	var activity = Ti.Android.currentActivity;
	activity.addEventListener('newintent', function(e) {
		Ti.API.info('- newintent');
		nfcAdapter.onNewIntent(e.intent);
	});

	activity.addEventListener('resume', function(e) {
		Ti.API.info('- resume');
		nfcAdapter.enableForegroundDispatch(dispatchFilter);
	});
	
	activity.addEventListener('pause', function(e) {
		Ti.API.info('- pause');
		nfcAdapter.disableForegroundDispatch();
	});
}

function handleDiscovery(e) {
	Ti.API.info(JSON.stringify(e, null, 2));
	alert(JSON.stringify(e, null, 2));
	var payload = e.messages[0].records[0].getPayload();
	Ti.API.info(payload);
	alert(payload);
};
